#include <avr/io.h>
#include "peri.h"

void init_peripheral()
{
    DDRB |= (1<<PB1); // set PD0 to output
    PORTB &= ~(1<<PB1);
    DDRB &= ~(1<<PB0);
    PORTB|=(1<<PB0);     // enable pullup register
    DDRC |= (1<<PC0);
    PORTD &= ~((1<<PD4) );
}

void ping_high_ultrasonic()
{
    PORTB |= (1<<PB1);
}

void ping_low_ultrasonic()
{
    PORTB &= ~(1<<PB1);
}
void beep(uint8_t x)
{
    PORTC &= 0b11111110;
    PORTC = PORTC |(1 & x);
}
uint16_t read_adc(uint8_t channel)
{
    ADMUX = (0<<REFS1)|(1<<REFS0) // ระบุให้ใช้ VCC เป็นแรงดันอ้างอิง (Vref) และ
          | (0<<ADLAR)            // บันทึกผลลัพธ์ชิดขวาในคู่รีจีสเตอร์ ADCH/ADCL
          | (channel & 0b1111);   // ตั้งค่า MUX เป็นค่า channel

    ADCSRA = (1<<ADEN)            // เปิดวงจร ADC
           | (1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0) // ใช้ความเร็ว 1/128 ของคล็อกระบบ
           | (1<<ADSC);           // สั่งวงจร ADC ให้เริ่มต้นการแปลง

    while ((ADCSRA & (1<<ADSC)))  // รอจนบิต ADSC กลายเป็น 0 ซึ่งหมายถึงการแปลงเสร็จสิ้น
       ;

    return ADCL + ADCH*256;  // ผลลัพธ์ถูกเก็บอยู่ในรีจีสเตอร์ ADCL และ ADCH
}

uint16_t get_light()
{
    return read_adc(PC4);
}