from practicum import McuBoard
from practicum import find_mcu_boards

RQ_GET_ECHO_TIME = 0
RQ_GET_LIGHT = 1
RQ_SET_BUZZER = 2

####################################
class McuWithPeriBoard(McuBoard):

    devs = find_mcu_boards()
    mcu = McuBoard(devs[0])

    ################################
    def getEchoTime(self):
        ret = bytearray()
        ret = self.mcu.usb_read(RQ_GET_ECHO_TIME, 2, 0, 0)
        return (((ret[0]+256)%256) + (ret[1]*256))

    def getLight(self):
        ret = bytearray()
        ret = self.mcu.usb_read(RQ_GET_LIGHT, 2, 0, 0)
        return (((ret[0]+256)%256) + (ret[1]*256))

    def setBuzzer(self, value):
        self.mcu.usb_write(RQ_SET_BUZZER, 0, value, value)
